#!/bin/bash

if [ "$1" == "1l2y_csa_4P" ]; then
 file=1l2y_csa_4P.CSA.history
elif [ "$1" == "1l2y_csa_local_4P" ]; then
 file=1l2y_csa_local_4P.CSA.history
elif [ "$1" == "1l2y_csa" ]; then
 file=1l2y_csa.CSA.history
elif [ "$1" == "1l2y_csa_local" ]; then
 file=1l2y_csa_local.CSA.history
else
 exit 1
fi

# Check if file exist
if [ ! -f $file ]; then
    echo "CRITICAL: out $file do not exist"
    exit 2
fi

emin=`grep jlee $file |awk '{print $10}'`
echo 'Emin= ' $emin

if [ "$1" == "1l2y_csa_4P" ]; then
 echo 'difference ' `echo "a=$emin+215.41208;if(0>a)a*=-1;a"|bc -l` ' from reference emin -215.41208'
 if [ `echo "a=$emin+215.41208;if(0>a)a*=-1;a>5.0"|bc -l` != "0" ]; then
  echo 'ERROR difference from reference emin -215.41208 greater than 5.0'
  exit 1
 fi
elif [ "$1" == "1l2y_csa_local_4P" ]; then
 echo 'difference ' `echo "a=$emin+200.13486;if(0>a)a*=-1;a"|bc -l` ' from reference emin -200.13486'
 grep rms 1l2y_csa_local_4P*.pdb
 if [ `echo "a=$emin+200.13486;if(0>a)a*=-1;a>5.0"|bc -l` != "0" ]; then
  echo 'ERROR difference from reference emin 200.13486 greater than 5.0'
  exit 1
 fi
elif [ "$1" == "1l2y_csa" ]; then
 echo 'difference ' `echo "a=$emin-29.92824;if(0>a)a*=-1;a"|bc -l` ' from reference emin 29.92824'
 if [ `echo "a=$emin-29.92824;if(0>a)a*=-1;a>5.0"|bc -l` != "0" ]; then
  echo 'ERROR difference from reference emin 29.92824 greater than 5.0'
  exit 1
 fi
elif [ "$1" == "1l2y_csa_local" ]; then
 echo 'difference ' `echo "a=$emin-31.52677;if(0>a)a*=-1;a"|bc -l` ' from reference emin 31.52677'
 grep rms 1l2y_csa_local_4P*.pdb
 if [ `echo "a=$emin-31.52677;if(0>a)a*=-1;a>5.0"|bc -l` != "0" ]; then
  echo 'ERROR difference from reference emin 31.52677 greater than 5.0'
  exit 1
 fi

fi
